commit:     8069922c8c22acaae7dde8ac2a479864b47f2294
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Mon Sep 12 18:04:04 2022 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Mon Sep 12 18:04:16 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=8069922c

sys-process/lsof: fix configure tests with Clang 15

Signed-off-by: Sam James <sam <AT> gentoo.org>

 .../files/lsof-4.95.0-clang-15-configure.patch     | 134 +++++++++++++++++++++
 sys-process/lsof/lsof-4.95.0-r1.ebuild             | 116 ++++++++++++++++++
 2 files changed, 250 insertions(+)

diff --git a/sys-process/lsof/files/lsof-4.95.0-clang-15-configure.patch 
b/sys-process/lsof/files/lsof-4.95.0-clang-15-configure.patch
new file mode 100644
index 000000000000..2e81a089e273
--- /dev/null
+++ b/sys-process/lsof/files/lsof-4.95.0-clang-15-configure.patch
@@ -0,0 +1,134 @@
+https://github.com/lsof-org/lsof/pull/248
+
+From 52f2c48790ced81aeef98807363ec94a867bbd88 Mon Sep 17 00:00:00 2001
+From: Sam James <s...@gentoo.org>
+Date: Mon, 12 Sep 2022 19:02:14 +0100
+Subject: [PATCH] Configure: fix configure tests broken with Clang 15
+ (-Wimplicit-int)
+
+Clang 15 makes -Wimplicit-int an error by default.
+
+Before this fix, configure would think localtime() and strftime() support
+was not present.
+
+Signed-off-by: Sam James <s...@gentoo.org>
+--- a/Configure
++++ b/Configure
+@@ -681,7 +681,7 @@ case $LSOF_TGT in  # {
+ 
+         rm -f ${LSOF_TMPC}.*
+         echo "#include <sys/systemcfg.h>" > ${LSOF_TMPC}.c
+-        echo 'main(){ if (__KERNEL_32()) printf("32\\n");' >> ${LSOF_TMPC}.c
++        echo 'int main(){ if (__KERNEL_32()) printf("32\\n");' >> 
${LSOF_TMPC}.c
+         echo 'else if (__KERNEL_64()) printf("64\\n");' >> ${LSOF_TMPC}.c
+         echo 'else printf("0\\n");' >> ${LSOF_TMPC}.c
+         echo "return(0); }" >> ${LSOF_TMPC}.c
+@@ -778,7 +778,7 @@ case $LSOF_TGT in  # {
+         rm -f ${LSOF_TMPC}.*
+         echo "#include <stddef.h>" > ${LSOF_TMPC}.c
+         echo "#include <sys/user.h>" >> ${LSOF_TMPC}.c
+-        echo "main(){exit((offsetof(struct user, U_irss) & 0x7) ? 1 : 0);}" 
>>${LSOF_TMPC}.c
++        echo "int main(){exit((offsetof(struct user, U_irss) & 0x7) ? 1 : 
0);}" >>${LSOF_TMPC}.c
+         echo "Testing user.h with $LSOF_CC"
+         $LSOF_CC ${LSOF_TMPC}.c -o ${LSOF_TMPC}.x
+         if ! ${LSOF_TMPC}.x   # {
+@@ -811,7 +811,7 @@ case $LSOF_TGT in  # {
+       # Get xlc version number
+ 
+       rm -f ${LSOF_TMPC}.*
+-      echo "main(){}" > ${LSOF_TMPC}.c
++      echo "int main(){}" > ${LSOF_TMPC}.c
+       echo "Getting version number of ${LSOF_CC}."
+       $LSOF_CC -c ${LSOF_TMPC}.c -I${LSOF_INCLUDE} -o ${LSOF_TMPC}.o -qlist > 
/dev/null 2>&1
+       LSOF_CCV=`head -1 ${LSOF_TMPC}.lst | sed 's/\(.*\) ---.*/\1/'`
+@@ -1783,7 +1783,7 @@ kernel generation process.
+         cat > ${LSOF_TMPC}.c << .LSOF_END_HERE_DOC3
+ #undef _KERNEL
+ #include <sys/types.h>
+-main() {
++int main() {
+ cpumask_t c;
+ }
+ .LSOF_END_HERE_DOC3
+@@ -2400,7 +2400,7 @@ LOCKF_OWNER4
+     # Test for "const void" support.
+ 
+     rm -f ${LSOF_TMPC}.*
+-    echo "main() { const void *x; return(0); }" >> $LSOF_TMPC.c
++    echo "int main() { const void *x; return(0); }" >> $LSOF_TMPC.c
+     $LSOF_CC $LSOF_TMPC.c -o $LSOF_TMPC.x > /dev/null 2>&1
+     if test $? -eq 0  # {
+     then
+@@ -2532,7 +2532,7 @@ LOCKF_OWNER4
+             echo ""
+             echo "Testing $LSOF_CC for 64 bit support"
+             rm -f ${LSOF_TMPC}.*
+-            echo "main(){}" > ${LSOF_TMPC}.c
++            echo "int main(){}" > ${LSOF_TMPC}.c
+             LSOF_TMP1=""
+             $LSOF_CC ${LSOF_TMPC}.c -o ${LSOF_TMPC}.x > /dev/null 2>&1
+             if test $? -eq 0  # {
+@@ -4605,7 +4605,7 @@ return(0); }
+       rm -f ${LSOF_TMPC}.*
+       echo "#define _KMEMUSER" > ${LSOF_TMPC}.c
+       echo "#include <sys/proc/prdata.h>" >> ${LSOF_TMPC}.c
+-      echo "main(){" >> ${LSOF_TMPC}.c
++      echo "int main(){" >> ${LSOF_TMPC}.c
+       echo "enum prnodetype p=PR_GWINDOWS;}" >> ${LSOF_TMPC}.c
+       echo "Testing prdata.h for PR_GWINDOWS, using $LSOF_CC"
+       echo $LSOF_CC | grep gcc > /dev/null
+@@ -4630,7 +4630,7 @@ return(0); }
+       rm -f ${LSOF_TMPC}.*
+       echo "#define _KMEMUSER" > ${LSOF_TMPC}.c
+       echo "#include <sys/proc/prdata.h>" >> ${LSOF_TMPC}.c
+-      echo "main(){" >> ${LSOF_TMPC}.c
++      echo "int main(){" >> ${LSOF_TMPC}.c
+       echo "enum prnodetype p=PR_LDT;}" >> ${LSOF_TMPC}.c
+       echo "Testing prdata.h for PR_LDT, using $LSOF_CC"
+       echo $LSOF_CC | grep gcc > /dev/null
+@@ -4675,7 +4675,7 @@ return(0); }
+ 
+           echo "Testing $LSOF_CC for 64 bit support"
+           rm -f ${LSOF_TMPC}.*
+-          echo "main(){}" > ${LSOF_TMPC}.c
++          echo "int main(){}" > ${LSOF_TMPC}.c
+           LSOF_TMP1=""
+ 
+       # First try gcc's -m64 option -- it's the most current possibility.
+@@ -4695,7 +4695,7 @@ return(0); }
+ 
+           # Try using the older -mcpu=v9 option with gcc instead of -m64.
+ 
+-            echo "main(){}" > ${LSOF_TMPC}.c
++            echo "int main(){}" > ${LSOF_TMPC}.c
+             $LSOF_CC ${LSOF_TMPC}.c -mcpu=v9 -o ${LSOF_TMPC}.x > /dev/null 
2>&1
+             if test $? -eq 0  # {
+             then
+@@ -4751,7 +4751,7 @@ return(0); }
+             echo "Testing $LSOF_CC for 64 bit $LSOF_TMP2 support"
+             rm -f ${LSOF_TMPC}.*
+             LSOF_TMP3="-xarch=$LSOF_TMP1"
+-            echo "main(){}" > ${LSOF_TMPC}.c
++            echo "int main(){}" > ${LSOF_TMPC}.c
+             LSOF_TMP4=`$LSOF_CC ${LSOF_TMPC}.c $LSOF_TMP3 -o ${LSOF_TMPC}.x 
2>&1`
+             if test $? -eq 0  # {
+             then
+@@ -5003,7 +5003,7 @@ return(0); }
+     then
+       rm -f ${LSOF_TMPC}.*
+       echo "#include <sys/vnode.h>" > ${LSOF_TMPC}.c
+-      echo "main(){" >> ${LSOF_TMPC}.c
++      echo "int main(){" >> ${LSOF_TMPC}.c
+       echo "enum vtype p=VSOCK;}" >> ${LSOF_TMPC}.c
+       echo "Testing vnode.h for VSOCK, using $LSOF_CC"
+       echo $LSOF_CC | grep gcc > /dev/null
+@@ -5490,7 +5490,7 @@ fi       # }
+ rm -f ${LSOF_TMPC}.*
+ cat > $LSOF_TMPC.c << .LSOF_END_HERE_DOC2
+ #include <time.h>
+-main(){
++int main(){
+   time_t cl;
+   struct tm *ts;
+   char bf[32];
+

diff --git a/sys-process/lsof/lsof-4.95.0-r1.ebuild 
b/sys-process/lsof/lsof-4.95.0-r1.ebuild
new file mode 100644
index 000000000000..b5cabe286fcd
--- /dev/null
+++ b/sys-process/lsof/lsof-4.95.0-r1.ebuild
@@ -0,0 +1,116 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit flag-o-matic toolchain-funcs
+
+MY_P="${P/-/_}"
+DESCRIPTION="Lists open files for running Unix processes"
+HOMEPAGE="https://github.com/lsof-org/lsof";
+SRC_URI="https://github.com/lsof-org/lsof/archive/${PV}.tar.gz -> ${P}.tar.gz"
+
+LICENSE="lsof"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~riscv 
~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~sparc-solaris 
~x64-solaris ~x86-solaris"
+IUSE="examples ipv6 rpc selinux"
+
+RDEPEND="rpc? ( net-libs/libtirpc )
+       selinux? ( sys-libs/libselinux )"
+DEPEND="${RDEPEND}"
+BDEPEND="sys-apps/groff
+       rpc? ( virtual/pkgconfig )"
+
+# Needs fixing first
+RESTRICT="test"
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-4.85-cross.patch # bug #432120
+       "${FILESDIR}"/${P}-test-typo.patch
+       "${FILESDIR}"/${PN}-4.95.0-clang-15-configure.patch
+)
+
+src_prepare() {
+       default
+       # fix POSIX compliance with `echo`
+       sed -i \
+               -e 's:echo -n:printf:' \
+               AFSConfig Configure Customize Inventory tests/CkTestDB || die
+       # Convert `test -r header.h` into a compile test.
+       # Make sure we convert `test ... -a ...` into two `test` commands
+       # so we can then convert both over into a compile test. #601432
+       sed -i -E \
+               -e '/if test .* -a /s: -a : \&\& test :g' \
+               -e '/test -r/s:test -r 
\$\{LSOF_INCLUDE\}/([[:alnum:]/._]*):echo "#include <\1>" | ${LSOF_CC} 
${LSOF_CFGF} -E - >/dev/null 2>\&1:g' \
+               -e 's:grep (.*) \$\{LSOF_INCLUDE\}/([[:alnum:]/._]*):echo 
"#include <\2>" | ${LSOF_CC} ${LSOF_CFGF} -E -P -dD - 2>/dev/null | grep \1:' \
+               Configure || die
+
+       # "create" man-page (bug #689462)
+       # inspired by shipped "makeman" ksh script
+       soelim < Lsof.8 > lsof.8 || die
+}
+
+target() {
+       case ${CHOST} in
+       *-darwin*)  echo darwin  ;;
+       *-freebsd*) echo freebsd ;;
+       *-solaris*) echo solaris ;;
+       *-aix*)     echo aixgcc  ;;
+       *)          echo linux   ;;
+       esac
+}
+
+src_configure() {
+       append-cppflags $(use rpc && $(tc-getPKG_CONFIG) libtirpc --cflags || 
echo "-DHASNOTRPC -DHASNORPC_H")
+       append-cppflags $(usex ipv6 -{D,U}HASIPv6)
+       [[ ${CHOST} == *-solaris2.11 ]] && append-cppflags -DHAS_PAD_MUTEX
+       if [[ ${CHOST} == *-darwin* ]] ; then
+               # make sys/proc_info.h available in ${T} because of LSOF_INCLUDE
+               # dummy location -- Darwin needs this for a Configure check to
+               # succeed
+               if [[ -e /usr/include/sys/proc_info.h ]] ; then
+                       mkdir -p "${T}"/sys || die
+                       ( cd "${T}"/sys && ln -s /usr/include/sys/proc_info.h ) 
|| die
+               fi
+       fi
+
+       export LSOF_CFGL="${CFLAGS} ${LDFLAGS} \
+               $(use rpc && $(tc-getPKG_CONFIG) libtirpc --libs)"
+
+       # Set LSOF_INCLUDE to a dummy location so the script doesn't poke
+       # around in it and mix /usr/include paths with cross-compile/etc.
+       touch .neverInv
+       LINUX_HASSELINUX=$(usex selinux y n) \
+       LSOF_INCLUDE=${T} \
+       LSOF_CC=$(tc-getCC) \
+       LSOF_AR="$(tc-getAR) rc" \
+       LSOF_RANLIB=$(tc-getRANLIB) \
+       LSOF_CFGF="${CFLAGS} ${CPPFLAGS}" \
+       ./Configure -n $(target) || die
+}
+
+src_compile() {
+       emake DEBUG="" all
+}
+
+src_install() {
+       dobin lsof
+
+       if use examples ; then
+               insinto /usr/share/lsof/scripts
+               doins scripts/*
+       fi
+
+       doman lsof.8
+       dodoc 00*
+}
+
+pkg_postinst() {
+       if [[ ${CHOST} == *-solaris* ]] ; then
+               einfo "Note: to use lsof on Solaris you need read permissions 
on"
+               einfo "/dev/kmem, i.e. you need to be root, or to be in the 
group sys"
+       elif [[ ${CHOST} == *-aix* ]] ; then
+               einfo "Note: to use lsof on AIX you need read permissions on 
/dev/mem and"
+               einfo "/dev/kmem, i.e. you need to be root, or to be in the 
group system"
+       fi
+}

Reply via email to